
//= rhjr: allocator

internal void
arena_init(Arena *arena, u8 *backing_buffer, i64 size)
{
  arena->backing_buffer = backing_buffer;
  arena->offset = 0;
  arena->size = size;
}

internal void *
arena_alloc(Arena *arena, i64 size)
{
  void *result = 0;

  if (arena->offset + size <= arena->size) {
    result = &arena->backing_buffer[arena->offset];
    arena->offset += size;
  } else {
    printf("Arena ran out of memory\n");
  }

  return result;
}

internal void
arena_release(Arena *arena)
{
  arena->offset = 0;
}

//= rhjr: string

String8
str8(u8 *cstr, i64 length)
{
  String8 result = {0};
  result.str    = cstr;
  result.length = length;
  return result;
}

String8
str8_cstring(u8 *cstr)
{
  String8 result = {0};
  u8 *ptr = cstr;
  for(; *ptr != 0; ptr += 1);
  result = str8_range(cstr, ptr);
  return result;
}

String8
str8_range(u8 *first_char, u8 *last_char)
{
  String8 result = {0};
  result.str    = first_char;
  result.length = (u64)(last_char - first_char);
  return result;
}

void
str8_list_push (Arena *arena, String8List *list, String8 string)
{
}

String8
str8_list_join(Arena *arena, String8List *list)
{
  String8 result = {0};

  return result;
}
